<< Prospective fun with jamming debit card payments | Home

Amazon EC2 boot script to associate elastic ip

After installation of the AWS API tools you can associate an elastic ip address to the instance from the instance itself during boot process.

I've written an SysV RC script.

For configuration you have to create a file /etc/ec2/elastic_ip

# cat /etc/ec2/elastic_ip
EC2_CERT=/etc/ec2/cert-HH3VN5NJXDWGGWRH72UP44XUCD4MQWRJ.pem
EC2_PRIVATE_KEY=/etc/ec2/pk-HH3VN5NJXDWGGWRH72UP44XUCD4MQWRJ.pem
EC2_URL=https://ec2.eu-west-1.amazonaws.com
EC2_ELASTIC_IP=x.x.x.x
Modify the configuration for your installation, key and cert.


The script itself:

# cat /etc/init.d/ec2-elastic-ip
#!/bin/sh
#
# Startup script to set AWS Elastic IP address on boot
#
# LSB compatible service control script; see http://www.linuxbase.org/spec/
#
### BEGIN INIT INFO
# Provides:          ec2-elastic-ip
# Required-Start:    $syslog $network
# Should-Start:      $time
# Required-Stop:     $syslog $network
# Should-Stop:       $time
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: ec2-elastic-ip setting script
# Description:       Associate the elastic ip address
#       from file /etc/ec2/elastic_ip to this instance
#       during boot.
### END INIT INFO

EC2_HOME=/opt/ec2-api-tools
export EC2_HOME

test -d "$EC2_HOME/bin" || { echo "ec2-api-tools not installed";
        if [ "$1" = "stop" ]; then exit 0;
        else exit 5; fi; }

JAVA_HOME=/etc/alternatives/jre
export JAVA_HOME

test -x "$JAVA_HOME/bin/java" || { echo "Java Runtime Environment not installed";
        if [ "$1" = "stop" ]; then exit 0;
        else exit 5; fi; }

EC2_ASSOC_IP="$EC2_HOME/bin/ec2-associate-address"

test -x $EC2_ASSOC_IP || { echo "$EC2_ASSOC_IP not installed";
        if [ "$1" = "stop" ]; then exit 0;
        else exit 5; fi; }

test -x $(which curl) || { echo "curl not installed";
        if [ "$1" = "stop" ]; then exit 0;
        else exit 5; fi; }

# Check for existence of needed config file and read it
EC2_IP_CONFIG=/etc/ec2/elastic_ip
test -r $EC2_IP_CONFIG || { echo "$EC2_IP_CONFIG not existing";
        if [ "$1" = "stop" ]; then exit 0;
        else exit 6; fi; }

# Read config
. $EC2_IP_CONFIG
export EC2_CERT
export EC2_PRIVATE_KEY
export EC2_URL

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0       - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
#
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

PATH="$PATH:$EC2_HOME/bin"
EC2_INSTANCE=$(curl -s -S http://169.254.169.254/latest/meta-data/instance-id)

case "$1" in
    start)
        $0 status
        if test $? != 0; then
                echo -n "Starting elastic ip association "
                address=$(ec2-associate-address -i "$EC2_INSTANCE" "$EC2_ELASTIC_IP")
                ip=$(echo "$address" | awk '{print $2}')
                instance=$(echo "$address" | awk '{print $3}')
                if [ "$ip" != "$EC2_ELASTIC_IP" ] || [ "$instance" != "$EC2_INSTANCE" ] ; then
                        rc_failed 1
                        # Remember status and be verbose
                        rc_status -v
                fi
        fi
        ;;
    stop)
        $0 status
        if test $? = 0; then
                echo -n "Shutting down elastic ip association "
                address=$(ec2-disassociate-address "$EC2_ELASTIC_IP")
        fi

        # Remember status and be verbose
        rc_status -v
        ;;
    try-restart|condrestart)
        ## Do a restart only if the service was active before.
        ## Note: try-restart is now part of LSB (as of 1.9).
        ## RH has a similar command named condrestart.
        if test "$1" = "condrestart"; then
                echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
        fi
        $0 status
        if test $? = 0; then
                $0 restart
        else
                rc_reset        # Not running is not a failure.
        fi
        # Remember status and be quiet
        rc_status
        ;;
    restart)
        ## Stop the service and regardless of whether it was
        ## running or not, start it again.
        $0 stop
        $0 start

        # Remember status and be quiet
        rc_status
        ;;
    force-reload)
        ## Signal the daemon to reload its config. Most daemons
        ## do this on signal 1 (SIGHUP).
        ## If it does not support it, restart the service if it
        ## is running.

        echo -n "Reload service elastic ip association "
        $0 try-restart
        rc_status
        ;;
    reload)
        ## Like force-reload, but if daemon does not support
        ## signaling, do nothing (!)

        ## Otherwise if it does not support reload:
        rc_failed 3
        rc_status -v
        ;;
    status)
        echo -n "Checking for service elastic ip association "
        ## Check status with checkproc(8), if process is running
        ## checkproc will return with exit status 0.

        # Return value is slightly different for the status command:
        # 0 - service up and running
        # 1 - service dead, but /var/run/  pid  file exists
        # 2 - service dead, but /var/lock/ lock file exists
        # 3 - service not running (unused)
        # 4 - service status unknown :-(
        # 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)

        address=$(ec2-describe-addresses | grep "$EC2_INSTANCE" 2>/dev/null)
        ip=$(echo "$address" | awk '{print $2}')
        if [ -z "$address" ] || [ "$EC2_ELASTIC_IP" != "$ip" ] ; then
                rc_failed 3
        else
                rc_failed 0
        fi

        # NOTE: rc_status knows that we called this init script with
        # "status" option and adapts its messages accordingly.
        rc_status -v
        ;;
    probe)
        ## Optional: Probe for the necessity of a reload, print out the
        ## argument to this init script which is required for a reload.
        ## Note: probe is not (yet) part of LSB (as of 1.9)

        #test /etc/FOO/FOO.conf -nt /var/run/FOO.pid && echo reload
        rc_failed 3
        rc_status -v
        ;;
    *)
        echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
        exit 1
        ;;
esac
rc_exit

Please check identation and new line after copy-and-paste!




Add a comment Send a TrackBack